
points = {}
pointHolder = {}

points.load = function(density)
	--random
	for i=1, density do
		pointHolder[i] = {x = math.random(), y = math.random(), z = math.random(), color = {math.random()*255, math.random()*255, math.random()*255}}
	end
end

points.render = function(pos, w, h)
	imageData = love.image.newImageData(w, h)
	for i=0, w-1 do
		for j=0, h-1 do
			pixel = getPixel(pos, (i+0.5)/w, (j+0.5)/h)
			
			imageData:setPixel(i, j, pixel[1], pixel[2], pixel[3])
		end
	end
	image = love.graphics.newImage(imageData)
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(image, 0, 0)
end

getPixel = function(pos, x, y)
	sampleSize = 3
	nearest = {}
	for i=1, sampleSize do
		nearest[i] = {dist = math.huge, id = 1}
	end
	
	for i=1, #pointHolder do
		for n=1, #nearest do
			dist = math.sqrt((x-pointHolder[i].x)^2 + (y-pointHolder[i].y)^2 + (pos-pointHolder[i].z)^2)
			if dist < nearest[n].dist then
				table.insert(nearest, n, {dist = dist, id = i})
				break
			end
		end
		
		while #nearest > sampleSize do
			table.remove(nearest, #nearest)
		end
	end
	
	pixel = {0, 0, 0}
	sumDist = 0
	for i=1, #nearest do
		for n=1, 3 do
			pixel[n] = pixel[n] + pointHolder[nearest[i].id].color[n] / nearest[i].dist
		end
		sumDist = sumDist + nearest[i].dist
	end
	for n=1, 3 do
		pixel[n] = pixel[n] * sumDist
	end
	
	return pixel
end